searchNodes=[{"doc":"Styler is a formatter plugin with stronger opinions on code organization, multi-line defs and other code-style matters.","ref":"Styler.html","title":"Styler","type":"module"},{"doc":"Turns an ast and comments back into code, formatting it along the way.","ref":"Styler.html#quoted_to_string/3","title":"Styler.quoted_to_string/3","type":"function"},{"doc":"Wraps Code.string_to_quoted_with_comments with our desired options","ref":"Styler.html#string_to_quoted_with_comments/2","title":"Styler.string_to_quoted_with_comments/2","type":"function"},{"doc":"A Style takes AST and returns a transformed version of that AST. Because these transformations involve traversing trees (the &quot;T&quot; in &quot;AST&quot;), we wrap the AST in a structure called a Zipper to facilitate walking the trees.","ref":"Styler.Style.html","title":"Styler.Style","type":"behaviour"},{"doc":"Deletes :line from the node's meta If you expected {:foo, foo_meta, [bar, baz, bop] to give you a a single line like foo(bar, baz, bop) but instead got foo( bar , baz , bop ) then it's likely that at least one of bar , baz , and/or bop have :line meta that's confusing the formatter and causing the multilining. This function fixes that problem. # =&gt; foo(bar, baz, bop)","ref":"Styler.Style.html#delete_line_meta/1","title":"Styler.Style.delete_line_meta/1","type":"function"},{"doc":"Set the line of all comments with line in range_start..range_end to instead have line range_start","ref":"Styler.Style.html#displace_comments/2","title":"Styler.Style.displace_comments/2","type":"function"},{"doc":"Ensure the parent node can have multiple children. If a context-changing node (a do end block or an -&gt; arrow block) is encountered the child is wrapped in a :__block__ Other nodes (pipes, assignments) can only have a fixed number of children. This function will recursively traverse up the zipper until it's found the parents of those nodes.","ref":"Styler.Style.html#ensure_block_parent/1","title":"Styler.Style.ensure_block_parent/1","type":"function"},{"doc":"run will be used with Zipper.traverse_while/3 , meaning it will be executed on every node of the AST. You can skip traversing parts of the tree by returning a Zipper that's further along in the traversal, for example by calling Zipper.skip(zipper) to skip an entire subtree you know is of no interest to your Style.","ref":"Styler.Style.html#c:run/2","title":"Styler.Style.run/2","type":"callback"},{"doc":"Change the line of all comments with line in range by adding delta to it. A positive delta will move the lines further down a file, while a negative delta will move them up.","ref":"Styler.Style.html#shift_comments/3","title":"Styler.Style.shift_comments/3","type":"function"},{"doc":"","ref":"Styler.Style.html#t:context/0","title":"Styler.Style.context/0","type":"type"},{"doc":"Styles function heads so that they're as small as possible. The goal is that a function head fits on a single line. This isn't a Credo issue, and the formatter is fine with either approach. But Styler has opinions! Ex: This long declaration def foo ( %{ bar : baz } ) do ... end Becomes def foo ( %{ bar : baz } ) do ... end","ref":"Styler.Style.Defs.html","title":"Styler.Style.Defs","type":"module"},{"doc":"Callback implementation for Styler.Style.run/2 .","ref":"Styler.Style.Defs.html#run/2","title":"Styler.Style.Defs.run/2","type":"function"},{"doc":"Styles up module directives! This Style will expand multi-aliases/requires/imports/use and sort the directive within its groups (except use s, which cannot be sorted) It also adds a blank line after each directive group. Credo rules Rewrites for the following Credo rules: Credo.Check.Consistency.MultiAliasImportRequireUse (force expansion) Credo.Check.Readability.AliasOrder (we sort __MODULE__ , which credo doesn't) Credo.Check.Readability.ModuleDoc (adds @moduledoc false if missing. includes *.exs files) Credo.Check.Readability.MultiAlias Credo.Check.Readability.StrictModuleLayout (see section below for details) Credo.Check.Readability.UnnecessaryAliasExpansion Strict Layout This can break your code. Modules directives are sorted into the following order: @shortdoc @moduledoc @behaviour use import alias require everything else (unchanged) If any of the sorted directives had a dependency on code that is now below it, your code will fail to compile after being styled. For instance, the following will be broken because the module attribute definition will be moved below the use clause, meaning @pi is undefined when invoked. # before defmodule Approximation do @pi 3.14 use Math , pi : @pi end # after defmodule Approximation do @moduledoc false use Math , pi : @pi @pi 3.14 end For now, it's up to you to come up with a fix for this issue. Sorry!","ref":"Styler.Style.ModuleDirectives.html","title":"Styler.Style.ModuleDirectives","type":"module"},{"doc":"Callback implementation for Styler.Style.run/2 .","ref":"Styler.Style.ModuleDirectives.html#run/2","title":"Styler.Style.ModuleDirectives.run/2","type":"function"},{"doc":"Styles pipes! In particular, don't make pipe chains of only one pipe, and some persnickety pipe chain start stuff. Rewrites for the following Credo rules: Credo.Check.Readability.BlockPipe Credo.Check.Readability.SinglePipe Credo.Check.Refactor.PipeChainStart, excluded_functions: [&quot;from&quot;] The following two rules are only corrected within pipe chains; nested functions aren't fixed Credo.Check.Refactor.FilterCount Credo.Check.Refactor.MapJoin Credo.Check.Refactor.MapInto","ref":"Styler.Style.Pipes.html","title":"Styler.Style.Pipes","type":"module"},{"doc":"Callback implementation for Styler.Style.run/2 .","ref":"Styler.Style.Pipes.html#run/2","title":"Styler.Style.Pipes.run/2","type":"function"},{"doc":"Simple 1-1 rewrites all crammed into one module to make for more efficient traversals Credo Rules addressed: Credo.Check.Readability.LargeNumbers Formatter handles large number (&gt;5 digits) rewrites, but doesn't rewrite typos like 100_000_0 , so it's worthwhile to have styler do this","ref":"Styler.Style.Simple.html","title":"Styler.Style.Simple","type":"module"},{"doc":"Callback implementation for Styler.Style.run/2 .","ref":"Styler.Style.Simple.html#run/2","title":"Styler.Style.Simple.run/2","type":"function"},{"doc":"Implements a Zipper for the Elixir AST based on Gérard Huet Functional pearl: the zipper paper and Clojure's clojure.zip API. A zipper is a data structure that represents a location in a tree from the perspective of the current node, also called focus . It is represented by a 2-tuple where the first element is the focus and the second element is the metadata/context. The metadata is nil when the focus is the topmost node","ref":"Styler.Zipper.html","title":"Styler.Zipper","type":"module"},{"doc":"Inserts the item as the rightmost child of the node at this zipper, without moving.","ref":"Styler.Zipper.html#append_child/2","title":"Styler.Zipper.append_child/2","type":"function"},{"doc":"Returns true if the node is a branch.","ref":"Styler.Zipper.html#branch?/1","title":"Styler.Zipper.branch?/1","type":"function"},{"doc":"Returns a list of children of the node.","ref":"Styler.Zipper.html#children/1","title":"Styler.Zipper.children/1","type":"function"},{"doc":"Returns the zipper of the leftmost child of the node at this zipper, or nil if no there's no children.","ref":"Styler.Zipper.html#down/1","title":"Styler.Zipper.down/1","type":"function"},{"doc":"Returns a zipper to the node that satisfies the predicate function, or nil if none is found. The optional second parameters specifies the direction , defaults to :next .","ref":"Styler.Zipper.html#find/3","title":"Styler.Zipper.find/3","type":"function"},{"doc":"Inserts the item as the leftmost child of the node at this zipper, without moving.","ref":"Styler.Zipper.html#insert_child/2","title":"Styler.Zipper.insert_child/2","type":"function"},{"doc":"Inserts the item as the left sibling of the node at this zipper, without moving. Raises an ArgumentError when attempting to insert a sibling at the top level.","ref":"Styler.Zipper.html#insert_left/2","title":"Styler.Zipper.insert_left/2","type":"function"},{"doc":"Inserts the item as the right sibling of the node at this zipper, without moving. Raises an ArgumentError when attempting to insert a sibling at the top level.","ref":"Styler.Zipper.html#insert_right/2","title":"Styler.Zipper.insert_right/2","type":"function"},{"doc":"Returns the zipper of the left sibling of the node at this zipper, or nil.","ref":"Styler.Zipper.html#left/1","title":"Styler.Zipper.left/1","type":"function"},{"doc":"Returns the leftmost sibling of the node at this zipper, or itself.","ref":"Styler.Zipper.html#leftmost/1","title":"Styler.Zipper.leftmost/1","type":"function"},{"doc":"Returns the following zipper in depth-first pre-order.","ref":"Styler.Zipper.html#next/1","title":"Styler.Zipper.next/1","type":"function"},{"doc":"Returns the node at the zipper.","ref":"Styler.Zipper.html#node/1","title":"Styler.Zipper.node/1","type":"function"},{"doc":"Returns the previous zipper in depth-first pre-order. If it's already at the end, it returns nil.","ref":"Styler.Zipper.html#prev/1","title":"Styler.Zipper.prev/1","type":"function"},{"doc":"Removes the node at the zipper, returning the zipper that would have preceded it in a depth-first walk.","ref":"Styler.Zipper.html#remove/1","title":"Styler.Zipper.remove/1","type":"function"},{"doc":"Replaces the current node in the zipper with a new node.","ref":"Styler.Zipper.html#replace/2","title":"Styler.Zipper.replace/2","type":"function"},{"doc":"Returns a new branch node, given an existing node and new children.","ref":"Styler.Zipper.html#replace_children/2","title":"Styler.Zipper.replace_children/2","type":"function"},{"doc":"Returns the zipper of the right sibling of the node at this zipper, or nil.","ref":"Styler.Zipper.html#right/1","title":"Styler.Zipper.right/1","type":"function"},{"doc":"Returns the rightmost sibling of the node at this zipper, or itself.","ref":"Styler.Zipper.html#rightmost/1","title":"Styler.Zipper.rightmost/1","type":"function"},{"doc":"Walks the zipper all the way up and returns the root node.","ref":"Styler.Zipper.html#root/1","title":"Styler.Zipper.root/1","type":"function"},{"doc":"Returns the zipper of the right sibling of the node at this zipper, or the next zipper when no right sibling is available. This allows to skip subtrees while traversing the siblings of a node. The optional second parameters specifies the direction , defaults to :next . If no right/left sibling is available, this function returns the same value as next/1 / prev/1 . The function skip/1 behaves like the :skip in traverse_while/2 and traverse_while/3 .","ref":"Styler.Zipper.html#skip/2","title":"Styler.Zipper.skip/2","type":"function"},{"doc":"Walks the zipper all the way up and returns the top zipper.","ref":"Styler.Zipper.html#top/1","title":"Styler.Zipper.top/1","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node. If the zipper is not at the top, just the subtree will be traversed. The function must return a zipper.","ref":"Styler.Zipper.html#traverse/2","title":"Styler.Zipper.traverse/2","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node with an accumulator. If the zipper is not at the top, just the subtree will be traversed.","ref":"Styler.Zipper.html#traverse/3","title":"Styler.Zipper.traverse/3","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node. The traversing will continue if the function returns {:cont, zipper} , skipped for {:skip, zipper} and halted for {:halt, zipper} If the zipper is not at the top, just the subtree will be traversed. The function must return a zipper.","ref":"Styler.Zipper.html#traverse_while/2","title":"Styler.Zipper.traverse_while/2","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node with an accumulator. The traversing will continue if the function returns {:cont, zipper, acc} , skipped for {:skip, zipper, acc} and halted for {:halt, zipper, acc} If the zipper is not at the top, just the subtree will be traversed.","ref":"Styler.Zipper.html#traverse_while/3","title":"Styler.Zipper.traverse_while/3","type":"function"},{"doc":"Returns the zipper of the parent of the node at this zipper, or nil if at the top.","ref":"Styler.Zipper.html#up/1","title":"Styler.Zipper.up/1","type":"function"},{"doc":"Replaces the current node in the zipper with the result of applying fun to the node.","ref":"Styler.Zipper.html#update/2","title":"Styler.Zipper.update/2","type":"function"},{"doc":"Creates a zipper from a tree node.","ref":"Styler.Zipper.html#zip/1","title":"Styler.Zipper.zip/1","type":"function"},{"doc":"","ref":"Styler.Zipper.html#t:command/0","title":"Styler.Zipper.command/0","type":"type"},{"doc":"","ref":"Styler.Zipper.html#t:path/0","title":"Styler.Zipper.path/0","type":"opaque"},{"doc":"","ref":"Styler.Zipper.html#t:tree/0","title":"Styler.Zipper.tree/0","type":"type"},{"doc":"","ref":"Styler.Zipper.html#t:zipper/0","title":"Styler.Zipper.zipper/0","type":"type"},{"doc":"Wraps errors raised by Styles during tree traversal.","ref":"Styler.StyleError.html","title":"Styler.StyleError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Styler.StyleError.html#message/1","title":"Styler.StyleError.message/1","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#main","title":"Changelog - main","type":"extras"},{"doc":"Improvements Sped up styling just a little bit","ref":"changelog.html#v0-5-1","title":"Changelog - v0.5.1","type":"extras"},{"doc":"Improvements Styler now implements Mix.Task.Format , meaning it is now an Elixir formatter plugin. See the README for new installation &amp; usage instructions Breaking Change! Wooo! the mix style task has been removed","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"Improvements Pipes rewrites |&gt; Enum.into(%{}[, mapper]) and Enum.into(Map.new()[, mapper]) to Map.new/1,2 calls","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"Improvements Pipes rewrites some two-step processes into one, fixing these credo issues in pipe chains: Credo.Check.Refactor.FilterCount Credo.Check.Refactor.MapJoin Credo.Check.Refactor.MapInto Fixes ModuleDirectives handles even weirder places to hide your aliases (anonymous functions, in this case) Pipes tries even harder to keep single-pipe rewrites of invocations on one line","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Fixes Pipes fixed omission of == as a valid pipe start operator (h/t @peake100 for the issue) fixed rewrite of a |&gt; b , where b was invoked without parenthesis","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"Improvements Enabled Defs style and overhauled it to properly handles comments Optimized and tweaked ModuleDirectives style Now culls newlines between &quot;groups&quot; of the same directive sorts @behaviour directives orders directives within non defmodule contexts (eg, a def do ) if there's at least one alias|require|use|import Fixes Pipes will try to keep single-pipe rewrites on one line","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Improvements Added ModuleDirectives style Note that this is potentially destructive in some rare cases. See moduledoc for more. This supersedes the Aliases style, which has been removed. mix style - reads and writes to stdin/stdout Fixes Pipes style is now aware of unless blocks","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Improvements Lots of README tweaking =) Optimized some Zipper operations Added Simple style, replacing the following Credo rule: Credo.Check.Readability.LargeNumbers Fixes Exceptions while parsing code now appropriately render filename rather than nofile:xx Fixed opaque Zipper.path() typespec implementation mismatches (thanks @sega-yarkin) Made ex_doc dev only, removing it as a dependency for users of Styler","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"Improvements Initial release of Styler Added Aliases style, replacing the following Credo rules: Credo.Check.Readability.AliasOrder Credo.Check.Readability.MultiAlias Credo.Check.Readability.UnnecessaryAliasExpansion Added Pipes style, replacing the following Credo rules: Credo.Check.Readability.BlockPipe Credo.Check.Readability.SinglePipe Credo.Check.Refactor.PipeChainStart Added Defs style (currently disabled by default)","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"},{"doc":"Styler is an Elixir formatter plugin that's combination of mix format and mix credo , except instead of telling you what's wrong, it just rewrites the code for you to fit its style rules.","ref":"readme.html","title":"Styler","type":"extras"},{"doc":"Add :styler as a dependency to your project's mix.exs : def deps do [ { :styler , &quot;~&gt; 0.5&quot; , only : [ :dev , :test ] , runtime : false } , ] end Add Styler as a plugin to your .formatter.exs file [ plugins : [ Styler ] , line_length : 100_000 ]","ref":"readme.html#installation","title":"Styler - Installation","type":"extras"},{"doc":"Styler is just a mix format plugin, so now your files will be styled whenever they're formatted. $ mix format Expect the initial styling of an existing codebase to take a while as it styles existing files and writes them to disk. Future runs will be just as fast as you're use to though.","ref":"readme.html#usage","title":"Styler - Usage","type":"extras"},{"doc":"You can find the currently-enabled styles in the Mix.Tasks.Style module, inside of its @styles module attribute. Each Style's moduledoc will tell you more about what it rewrites. Examples The best place to get an idea of what sorts of changes Styler makes is by looking at its tests! Someday we'll announce Styler to the world, and hopefully by then we have some examples written into this here README :) Credo Rules Styler Replaces Credo.Check Styler.Style Style notes Credo.Check.Consistency.MultiAliasImportRequireUse Styler.Style.ModuleDirectives always expands A.{B, C} Credo.Check.Readability.AliasOrder Styler.Style.ModuleDirectives Credo.Check.Readability.BlockPipe Styler.Style.Pipes Credo.Check.Readability.LargeNumbers Styler.Style.Simple fixes bad underscores, ie: 100_00 Credo.Check.Readability.ModuleDoc Styler.Style.ModuleDirectives adds @moduledoc false Credo.Check.Readability.MultiAlias Styler.Style.ModuleDirectives Credo.Check.Readability.SinglePipe Styler.Style.Pipes Credo.Check.Readability.StrictModuleLayout Styler.Style.ModuleDirectives potentially destructive! (see moduledoc) Credo.Check.Readability.UnnecessaryAliasExpansion Styler.Style.ModuleDirectives Credo.Check.Refactor.PipeChainStart Styler.Style.Pipes Credo.Check.Refactor.FilterCount Styler.Style.Pipes (in pipes only) Credo.Check.Refactor.MapJoin Styler.Style.Pipes (in pipes only) Credo.Check.Refactor.MapInto Styler.Style.Pipes (in pipes only) If you're using Credo and Styler, we recommend disabling these rules in Credo to save on unnecessary checks in CI.","ref":"readme.html#styles","title":"Styler - Styles","type":"extras"},{"doc":"Sourceror This work was inspired by earlier large-scale rewrites of an internal codebase that used the fantastic tool Sourceror . The initial implementation of Styler used Sourceror, but Sourceror's AST-embedding comment algorithm slows Styler down to the point that it's no longer an appropriate drop-in for mix format . Still, we're grateful for the inspiration Sourceror provided and the changes to the Elixir AST APIs that it drove. The AST-Zipper implementation in this project was forked from Sourceror's implementation. Credo Similarly, this project originated from one-off scripts doing large scale rewrites of an enormous codebase as part of an effort to enable particular Credo rules for that codebase. Credo's tests and implementations were referenced for implementing Styles that took the work the rest of the way. Thanks to Credo &amp; the Elixir community at large for coalescing around many of these Elixir style credos.","ref":"readme.html#thanks-inspiration","title":"Styler - Thanks &amp; Inspiration","type":"extras"}]